function SSOmatrix = SSO_matrix_calc(signal,sigma) 
%%% This code calcualte the SSO matrix
%%% "signal" is the input signal 
%%% "sigma" is the input parameter for Gaussian function,"WindowWidth" is
%%% the width 'a' of window function h(x)
%%% Outputs:  "SSO matrix"

N = length(signal);
%% Parameters (They need to be adjusted in different applications)
j = [-N/2+1:N/2-1];
TimeVariable_0 = j/N;
gf = 1/(sqrt(2*pi)*sigma) * exp(-TimeVariable_0.^2/(2*sigma^2));   % Gaussian function
% ThetaVariable = pi*[0:2*N-1]/(2*N); % Thelta points this should be on 0,piaccording to the SSO demo
ThetaVariable = pi*[0:N/2-1]/(N/2);
%% Padding, symmetric  M = 2*N
sleft = flipud(signal(2:N/2+1));
sright = flipud(signal(end-N/2:end-1));
x = [sleft signal sright];
clear xleft xright;
n1 = length(sleft);


%% Calculate \TauF(t,thelta) named SSOmatrix by SSO
 SSOmatrix = zeros(N,length(ThetaVariable));
for k = 1:N
    for n = 1:length(ThetaVariable)
        x_trun = x(k+n1-N/2+1:k+n1+N/2-1);
        SSOmatrix(k,n) = sum(gf.*x_trun.*exp(1i*ThetaVariable(n)*j));
    end
end
